
//DESACTIVAR EL BOTN CERRAR Y LA FUNCIN DE CIERRE CON ALT+F4

//.NET Framework proporciona libreras para muchas APIs del sistema, son las libreras manejadas 
//o gestionadas (managed libraries), pero hay muchas otras libreras de Windows que carecen de 
//equivalente en .NET.
//Estas libreras tambin pueden ser utilizadas desde .NET gracias a los servicios de invocacin de 
//plataforma (PInvoke = Platfotm Invoque) que permiten utilizar libreras no manejadas (APIs de 
//Windows como por ejemplo user32.dll) en los proyectos .NET.
//Para ello se importa el espacio de nombres System.Runtime.InteropServices

//En esta aplicacin se usa el tipo de dato IntPtr. Se ha diseado el tipo IntPtr para que sea un nmero entero
// cuyo tamao sea especfico de la plataforma. Es decir, se espera que una instancia de este tipo tenga lugar
//en sistemas operativos y hardware de 32 bits y en sistemas operativos y hardware de 64 bits, y que funcione
//correctamente en ambos sistemas.
//El tipo IntPtr se puede utilizar por idiomas que admiten punteros y como un medio comn para hacer referencia
//a los datos entre idiomas que admiten o no punteros. El tipo IntPtr es compatible con CLS (Common Language 
//Specification), conjunto de caractersticas bsicas de lenguaje englobadas en .NET Framework.
//El tipo IntPtr pertenece al espacio de nombres System.

//Importar espacios de nombres para la aplicacin
using System;
using System.Windows.Forms;
//using System.Drawing;
//using System.Collections;
//using System.ComponentModel;
//using System.Data;

//Para leer procedimientos externos radicados en libreras de windows se
//usan los servicios de invocacin de plataforma (PInvoke) 
using System.Runtime.InteropServices;

namespace emiCerrar
{
	// <summary>
	// Descripcin breve
    // </summary>
	public class Form1 : System.Windows.Forms.Form
	{
		private System.ComponentModel.IContainer components;        
		/// <summary>
		public Form1()
		{
			//
			// Necesario para admitir el Diseador de Windows Forms
			//
			InitializeComponent();
			//
			// TODO: agregar cdigo de constructor despus de llamar a InitializeComponent
			//
		}
		/// <summary>
		/// Limpiar los recursos que se estn utilizando.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Cdigo generado por el Diseador de Windows Forms
		/// <summary>
		/// Mtodo necesario para admitir el Diseador. No se puede modificar
		/// el contenido del mtodo con el editor de cdigo.
		/// </summary>
		private void InitializeComponent()
		{
            System.ComponentModel.ComponentResourceManager resources = new System.ComponentModel.ComponentResourceManager(typeof(Form1));
            this.button1 = new System.Windows.Forms.Button();
            this.button2 = new System.Windows.Forms.Button();
            this.SuspendLayout();
            // 
            // button1
            // 
            this.button1.Font = new System.Drawing.Font("Verdana", 14.25F);
            this.button1.Location = new System.Drawing.Point(32, 44);
            this.button1.Name = "button1";
            this.button1.Size = new System.Drawing.Size(304, 148);
            this.button1.TabIndex = 0;
            this.button1.Text = "Desactivar botn";
            this.button1.Click += new System.EventHandler(this.button1_Click);
            // 
            // button2
            // 
            this.button2.Font = new System.Drawing.Font("Verdana", 14.25F);
            this.button2.Location = new System.Drawing.Point(368, 44);
            this.button2.Name = "button2";
            this.button2.Size = new System.Drawing.Size(208, 148);
            this.button2.TabIndex = 1;
            this.button2.Text = "Salir";
            this.button2.Click += new System.EventHandler(this.button2_Click);
            // 
            // Form1
            // 
            this.AutoScaleDimensions = new System.Drawing.SizeF(192F, 192F);
            this.AutoScaleMode = System.Windows.Forms.AutoScaleMode.Dpi;
            this.ClientSize = new System.Drawing.Size(617, 253);
            this.Controls.Add(this.button2);
            this.Controls.Add(this.button1);
            this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedSingle;
            this.Icon = ((System.Drawing.Icon)(resources.GetObject("$this.Icon")));
            this.MaximizeBox = false;
            this.MinimizeBox = false;
            this.Name = "Form1";
            this.StartPosition = System.Windows.Forms.FormStartPosition.CenterScreen;
            this.Text = " Botn cerrar";
            this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// Punto de entrada principal de la aplicacin.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new Form1());
		}

        // botones para usar en el formulario
		private System.Windows.Forms.Button button1;
		private System.Windows.Forms.Button button2;
		
		//Declaracin de constantes necesarias (valores en hexadecimal)
		private const int MF_BYPOSITION = 0x400; //posicin de cada tem en el men
        private const int MF_DISABLED = 0x2; //tem del men deshabilitado
        //private const int MF_REMOVE = 0x1000;

        //Variable para saber si ya est desactivado el botn X
        private bool pulsado = true;

		//Importacin de procedimientos externos almacenados en la librera de Windows USER32.DLL

		//Quitar elementos del men de sistema
		[DllImport("user32.Dll")]
		public static extern IntPtr RemoveMenu(int hMenu, int nPosition,int wFlags); 

		//Obtener el men de sistema
		[DllImport("User32.Dll")]
		public static extern IntPtr GetSystemMenu(int hWnd, bool bRevert);

		//Obtener el nmero de elementos del men de sistema
		[DllImport("User32.Dll")]
		public static extern IntPtr GetMenuItemCount(int hMenu);

		//Redibujar la barra de ttulo de la ventana
		[DllImport("User32.Dll")]
		public static extern IntPtr DrawMenuBar(int hwnd);

		//Mtodo que desactiva el botn X (cerrar)
		public void DisableCloseButton(int hWnd)
		{
			IntPtr hMenu;
			IntPtr menuItemCount;
			//Obtener el manejador del men de sistema del formulario
			hMenu = GetSystemMenu(hWnd, false);
            //Obtener la cuenta de los tems del men de sistema.
            //Es el men que aparece al pulsar sobre el icono a la izquierda de la Barra de ttulo de la ventana,
            //consta de los tems: Restaurar, Mover, Tamao, Minimizar, Maximizar, Separador, Cerrar
            //cada tem tiene un ndice asignado empezando por Cerrar (el ltimo tem)
			menuItemCount = GetMenuItemCount(hMenu.ToInt32());
            //Quitar el tem Close (Cerrar), que es el ltimo de ese men
			RemoveMenu(hMenu.ToInt32(), menuItemCount.ToInt32() - 1,MF_DISABLED | MF_BYPOSITION);
			//Quitar el tem Separador, el penltimo de ese men, entre Maximizar y Cerrar
			RemoveMenu(hMenu.ToInt32(), menuItemCount.ToInt32() - 2, MF_DISABLED | MF_BYPOSITION);
			//Redibujar la barra de men con el aspecto nuevo
			DrawMenuBar(hWnd);
		}	

		//Al pulsar el botn Desactivar
		private void button1_Click(object sender, System.EventArgs e)
		{
			if (pulsado)
			{
				//Mtodo al que se le pasa como parmetro el identificador de la ventana sobre la que actuar
				DisableCloseButton(this.Handle.ToInt32());
				//Aviso al usuario, no funciona el botn cerrar ni ALT+F4
				MessageBox.Show ("El botn Cerrar ha sido desactivado.\nPulsa Salir para cerrar la aplicacin",	"Cerrar desactivado 1");
				pulsado = false;
			}
			else
			{
				MessageBox.Show ("Ya habas pulsado aqu.\nPulsa Salir para cerrar la aplicacin",	"Cerrar desactivado 2");
			}
		}

		//Al pulsar el botn Salir
		private void button2_Click(object sender, System.EventArgs e)
		{
			//Salir de la aplicacin
			Application.Exit();
		}

	}
}
